﻿
namespace Yuuna.Contracts.Optimization
{
    using System.Collections.Immutable;
    using Yuuna.Contracts.Patterns;
    using System.Linq;
    using Yuuna.Contracts.Semantics;
    using Yuuna.Contracts.Plugins;

    internal struct Score : IScore
    {
        internal Score(PluginBase owner,IImmutableList<IPair> matches, IPattern contrast)
        {
            this.Contrast = contrast;
            this.Plugin = owner;
            this.SequentialMatches = matches;

            this.IsCompacted = contrast.Count == matches.Count;
            this.Coverage = (double)matches.Count / contrast.Count;
            this.Missing = contrast.ToImmutable().Except(matches.Select(x => x.Synonym.Owner)).ToImmutableArray();
        }

        public PluginBase Plugin { get; }
        public IImmutableList<IPair> SequentialMatches { get; }
        /// <summary>
        /// 比較的文法。
        /// </summary>
        public IPattern Contrast { get; }

        public bool IsCompacted { get; }
        public double Coverage { get; }
        public IImmutableList<IGroup> Missing { get; }
    }

}