﻿
namespace Yuuna.Contracts.Patterns
{
    using System;
    using Yuuna.Contracts.Artisan.Cascade;

    internal sealed class InvokeBuilder : Pipeline<IncompleteBuilder, Invoke>, IInvokeBuilder
    {
        public IIncompleteBuilder OnInvoke(Invoke invoke)
        {
            if (invoke is null)
                throw new ArgumentNullException(nameof(invoke));
            return this.MoveNext(invoke);
        }
    } 
}