﻿
namespace Yuuna.Contracts.Patterns
{
    using System;
    using System.Collections.Concurrent;
    using System.Collections.Generic;
    using System.Collections.Immutable;
    using Yuuna.Contracts.Artisan.Cascade;
    using Yuuna.Contracts.Semantics;

    internal sealed class PatternFactory : Initial<InvokeBuilder,IPattern>, IPatternSet, IPatternBuilder
    { 
        private readonly ConcurrentDictionary<IPattern, Bag> _list;
        public PatternFactory()
        {
            this._list = new ConcurrentDictionary<IPattern, Bag>();
        }

        protected override void OnCompleted(Queue<object> session)
        { 
                 
            var ge = new Bag
            {
                Pattern = session.Dequeue() as IPattern,
                Invoke = session.Dequeue() as Invoke,
                Incomplete = session.Dequeue() as Incomplete,
            };
            System.Console.WriteLine(this._list.TryAdd(ge.Pattern, ge));
        }
         
        public bool TryGet(IPattern pattern, out Invoke invoke)
        {
            var b = this._list.TryGetValue(pattern, out var s);
            System.Console.WriteLine(b);
            invoke = s.Invoke;
            return b;
        }
        public IImmutableList<IPattern> ToImmutable() => this._list.Keys.ToImmutableArray();

        public IInvokeBuilder Build(IGroup group, params IGroup[] rest)
        {

            if (group is null)
                throw new ArgumentNullException(nameof(group));

            var g = new Pattern();
            g.Add(group);
            if (rest != null)
                foreach (var item in rest)
                    g.Add(item);
            g.Immute();

            return this.MoveNext(g);
        }
    }
}