﻿
namespace Yuuna.Contracts.Plugins
{
    using Yuuna.Contracts.Interaction;
    using Yuuna.Contracts.Patterns;
    using Yuuna.Contracts.Semantics;
    using Yuuna.Contracts.Utilities;

    public sealed class Fake : PluginBase
    {
        protected override void BuildPatterns(IGroupManager g, IPatternBuilder p)
        {
            g.Define("open").AppendOrCreate(new[] { "打開", "開" });
            g.Define("door").AppendOrCreate(new[] { "門", "房間門" });
            g.Define("light").AppendOrCreate(new[] { "燈", "檯燈" });
            //g.Define("browser").AppendOrCreate(new[] { "瀏覽器", "chrome" });

            p.Build(g["open"], g["door"]).OnInvoke(score =>
            {
                var DOOR = new { IS_OPENED = new[] { true, false, true, false }.RandomTakeOne() };
                // 開門
                if (!DOOR.IS_OPENED)
                    return (Moods.Happy, "已經開好門囉 <3");
                else
                    return (Moods.Sad, "可是門本來就是開的欸 QAQ");
            }).OnImcomplete(s=>"");

            p.Build(g["open"], g["light"]).OnInvoke(score =>
            {
                var LIGHT = new { IS_OPENED = new[] { true, false, true, false }.RandomTakeOne() };
                // 開門
                if (!LIGHT.IS_OPENED)
                    return (Moods.Happy, "已經開好燈囉 <3");
                else
                    return (Moods.Sad, "可是燈本來就是開的欸 QAQ");
            }).OnImcomplete(s => "");

            //p.Build(g["open"], g["browser"]).OnInvoke(score =>
            //{
            //    var DOOR = new { IS_OPENED = true };
            //    // 開門
            //    if (!DOOR.IS_OPENED)
            //        return (Moods.Happy, "已經開好門囉 <3");
            //    else
            //        return (Moods.Sad, "可是門本來就是開的欸 QAQ");
            //});
        }
    }

}
